#include <stdio.h>

#define ZERO (0)
#define PIU  (1)
#define ZP   (2)
#define PZ   (3)

char bit[32];  // Array che conterr i bit da codificare

char oqa0[32]; // Array che conterranno le triplette di caratteri grafici per i bit da codificare
char oqb0[32];
char oqa1[32];
char oqb1[32];
char oqa2[32];
char oqb2[32];


void BitOnda(int i, int come);
void StampaOnda(int quanti);


int main()
{
    int i,j;
    int precedente;

    // Ecco i bit da codificare
    i = 0;
    bit[i++] = 1;
    bit[i++] = 0;
    bit[i++] = 1;
    bit[i++] = 0;
    bit[i++] = 0;
    bit[i++] = 0;
    bit[i++] = 0;
    bit[i++] = 1;
    bit[i++] = 1;
    bit[i++] = 1;


    j = i;


    precedente = 1;  // Per ipotesi


    // Algoritmo per NRZ
    // .....................................

    for (i=0; i<j; i++)
    {
      if (bit[i]==1)
      {
        if (precedente==1)
        {
          BitOnda(i,PIU);
        }
        else
        {
          BitOnda(i,ZP);
        }
      }
      else
      {
        if (precedente==1)
        {
          BitOnda(i,PZ);
        }
        else
        {
          BitOnda(i,ZERO);
        }
      }

      precedente = bit[i];
    }

    StampaOnda(i);

    return 0;
}


void BitOnda(int i, int come)
{
  switch (come)
  {
    case ZERO:
      oqa0[i] = ' '; oqa1[i] = ' '; oqa2[i] = ' ';
      oqb0[i] = 196; oqb1[i] = 196; oqb2[i] = 196;
    break;

    case PIU:
      oqa0[i] = 196; oqa1[i] = 196; oqa2[i] = 196;
      oqb0[i] = ' '; oqb1[i] = ' '; oqb2[i] = ' ';
    break;

    case ZP:
      oqa0[i] = 218; oqa1[i] = 196; oqa2[i] = 196;
      oqb0[i] = 217; oqb1[i] = ' '; oqb2[i] = ' ';
    break;

    case PZ:
      oqa0[i] = 191; oqa1[i] = ' '; oqa2[i] = ' ';
      oqb0[i] = 192; oqb1[i] = 196; oqb2[i] = 196;
    break;
  }

}

void StampaOnda(int quanti)
{
  int i;
    printf("\nBit\n");

    for (i=0;i<quanti;i++)
    {
      printf("%c",bit[i] + '0');
    }

    printf("\nSegnale\n");

    for (i=0;i<quanti;i++)
    {
      printf("%c",oqa0[i]);
      printf("%c",oqa1[i]);
      printf("%c",oqa2[i]);
    }
    printf("\n");

    for (i=0;i<quanti;i++)
    {
      printf("%c",oqb0[i]);
      printf("%c",oqb1[i]);
      printf("%c",oqb2[i]);
    }

}

